;HotKeys: 	Strg-UP    ==> Eingabe der Geschwindigkeit 1 - 100
;         	Strg-DOWN  ==> beendet die CursorMouse
;         	Strg-LEFT  ==> linke Maustaste klickt
;         	Strg-RIGHT ==> rechte Maustaste klickt
;			Strg-SPACE ==> Klick linke Maustaste
;			Strg-ENTER ==> Klick rechte Mausttaste
;			Strg-F1    ==> Anzeige der Hilfe

#include <Timers.au3>
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>
#include <WINAPI.au3>
#include <GuiSlider.au3>
#include <Constants.au3>
#include <EditConstants.au3>
#include <Misc.au3>
If _Singleton("CursorMaus", 1) = 0 Then Exit
Opt("TrayMenuMode", 1)
Opt("MustDeclareVars", 1)
Global $settingsitem = TrayCreateItem("Konfiguration")
TrayCreateItem("")
Global $aboutitem = TrayCreateItem("ber")
TrayCreateItem("")
Global $exititem = TrayCreateItem("Ende")
TraySetState()
Global $speed = 5 ; Eingabe der Maus-Geschwindigkeit von 1 - 10 ( Standard = 5 )
Global $acceleration = 0 ; Beschleunigung bei anhaltendem drcken einer Cursor-Taste => Werte 0 - 5 ( Standard = 0 => keine Beschleunigung )
Global $einblenden = 5
$speed /= 100
$acceleration /= 20000
Global $pos, $step, $accel, $timer, $test, $msg, $tmsg, $pos_alt
Global $dll
Global $gui = GUICreate('Cursor-Maus (inaktiv)', 340, 220, -1, -1, -1, $WS_EX_LAYERED)
GUISetIcon("ico\mouse.ico")
_WinAPI_SetLayeredWindowAttributes($gui, 0x010101, 0)
GUICtrlCreateIcon("ico\mouse.ico", "", 10, 100, 128, 128)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateLabel("Geschwindigkeit:", 10, 20, 86, 17)
GUICtrlCreateLabel("Beschleunigung:", 10, 70, 83, 17)
GUICtrlCreateLabel("1", 100, 20, 10, 20)
GUICtrlCreateLabel("10", 280, 20, 15, 20)
Global $Slider1 = GUICtrlCreateSlider(110, 15, 170, 30, BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS, $WS_TABSTOP))
GUICtrlSetLimit(-1, 10, 1)
_GUICtrlSlider_SetTicFreq($Slider1, 1)
_GUICtrlSlider_SetThumbLength($Slider1, 10)
Global $Slider1_Wert = GUICtrlCreateLabel("", 305, 15, 25, 30, $ES_CENTER)
GUICtrlSetFont(-1, 10, 900)
GUICtrlSetData(-1, $speed * 100)
GUICtrlCreateLabel("0", 100, 70, 10, 20)
GUICtrlCreateLabel("5", 280, 70, 15, 20)
Global $Slider2 = GUICtrlCreateSlider(110, 65, 170, 30, BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS, $WS_TABSTOP))
GUICtrlSetLimit(-1, 5, 0)
_GUICtrlSlider_SetTicFreq($Slider2, 1)
_GUICtrlSlider_SetThumbLength($Slider2, 10)
Global $button = GUICtrlCreateButton("bernehmen", 160, 120, 130, 80, $WS_TABSTOP)
GUICtrlSetFont(-1, 12, 600)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
_hotkeyson()
TraySetIcon("ico\mouse.ico")
$timer = TimerInit()
_about()

While 1
	$msg = GUIGetMsg()
	$tmsg = TrayGetMsg()
	Switch $msg
		Case -3
			Exit
	EndSwitch
	Switch $tmsg
		Case $exititem
			Exit
		Case $settingsitem
			_setspeed()
		Case $aboutitem
			_about()
	EndSwitch
WEnd

GUIDelete()
Exit

Func _cursorleft()
	$pos_alt = MouseGetPos()
	While _IsPressed("25")
		If _accel() >= 1 Then
			$pos = MouseGetPos()
			MouseMove($pos[0] - $step, $pos[1], 0)
			$step = 0
		EndIf
	WEnd
	$accel = 0
EndFunc   ;==>_cursorleft

Func _cursorleft_original()
	While _IsPressed("25")
		If _accel() >= 1 Then
			$pos = MouseGetPos()
			MouseMove($pos[0] - $step, $pos[1], 0)
			$step = 0
		EndIf
	WEnd
	$accel = 0
EndFunc   ;==>_cursorleft

Func _cursorup()
	While _IsPressed("26")
		If _accel() >= 1 Then
			$pos = MouseGetPos()
			MouseMove($pos[0], $pos[1] - $step, 0)
			$step = 0
		EndIf
	WEnd
	$accel = 0
EndFunc   ;==>_cursorup

Func _cursorright()
	While _IsPressed("27")
		If _accel() >= 1 Then
			$pos = MouseGetPos()
			MouseMove($pos[0] + $step, $pos[1], 0)
			$step = 0
		EndIf
	WEnd
	$accel = 0
EndFunc   ;==>_cursorright

Func _cursordown()
	While _IsPressed("28")
		If _accel() >= 1 Then
			$pos = MouseGetPos()
			MouseMove($pos[0], $pos[1] + $step, 0)
			$step = 0
		EndIf
	WEnd
	$accel = 0
EndFunc   ;==>_cursordown

Func _accel()
	$accel += $acceleration
	$step += $speed + ($accel * $speed)
	Return $step
EndFunc   ;==>_accel

Func _setspeed()
	TrayItemSetState($settingsitem, $TRAY_UNCHECKED)
	Local $speedtemp = $speed * 100, $msg
	GUICtrlSetData($Slider1, $speedtemp)
	GUICtrlSetData($Slider2, $acceleration * 20000)
	_hotkeysoff()
	GUICtrlSetState($button, $GUI_FOCUS)
	GUISetState(@SW_SHOW)
	Send("{TAB}")
	For $i = 1 To 255 Step $einblenden
		_WinAPI_SetLayeredWindowAttributes($gui, 0x010101, $i)
	Next
	While 1
		$msg = GUIGetMsg()
		Switch $msg
			Case -3, $button
				ExitLoop
			Case $Slider1
				GUICtrlSetData($Slider1_Wert, GUICtrlRead($Slider1))
		EndSwitch
	WEnd
	For $i = 255 To 0 Step -$einblenden
		_WinAPI_SetLayeredWindowAttributes($gui, 0x010101, $i)
	Next
	GUISetState(@SW_HIDE)
	$speed = GUICtrlRead($Slider1) / 100
	$acceleration = GUICtrlRead($Slider2) / 20000
	_hotkeyson()
EndFunc   ;==>_setspeed

Func _clickleft()
	MouseClick("left")
EndFunc   ;==>_clickleft

Func _clickright()
	MouseClick("right")
EndFunc   ;==>_clickright

Func _hotkeyson()
	TraySetIcon("ico\mouse.ico")
	HotKeySet("{left}", "_cursorleft")
	HotKeySet("{right}", "_cursorright")
	HotKeySet("{up}", "_cursorup")
	HotKeySet("{down}", "_cursordown")
	HotKeySet("^{down}", "_exit")
	HotKeySet("^{up}", "_setspeed")
	HotKeySet("^{LEFT}", "_clickleft")
	HotKeySet("^{RIGHT}", "_clickright")
	HotKeySet("^{F1}", "_about")
EndFunc   ;==>_hotkeyson

Func _hotkeysoff()
	TraySetIcon("ico\no_mouse.ico")
	HotKeySet("{left}")
	HotKeySet("{right}")
	HotKeySet("{up}")
	HotKeySet("{down}")
	HotKeySet("^{LEFT}")
	HotKeySet("^{RIGHT}")
	HotKeySet("^{F1}")
EndFunc   ;==>_hotkeysoff

Func _about()
	TrayItemSetState($aboutitem, $TRAY_UNCHECKED)
	Global $aboutgui = GUICreate('ber Cursor-Maus', 360, 230, -1, -1, -1, $WS_EX_LAYERED)
	_WinAPI_SetLayeredWindowAttributes($gui, 0x010101, 0)
	GUISetIcon("ico\mouse.ico")
	GUICtrlCreateLabel("Anleitung:" & @CRLF & "Maussteuerung mit den Pfeiltasten" & @CRLF & @CRLF & "Strg + Pfeil-Nach-Oben" & @TAB & @TAB & "==> Konfiguration" & @CRLF & "Strg + Pfeil-Nach-Unten" & @TAB & @TAB & "==> Ende" & @CRLF & _
			"Strg + Pfeil-Nach-Links" & @TAB & @TAB & "==> Mausklick links" & @CRLF & "Strg + Pfeil-Nach-Rechts" & @TAB & @TAB & "==> Mausklick rechts" & @CRLF & "Strg + F1" & @TAB & @TAB & @TAB & "==> diese Hilfeseite" & @CRLF & @CRLF & "verlassen des Men's mit Esc", 10, 10, 280, 110)
	GUICtrlCreateIcon("ico\mouse.ico", "", 10, 115, 128, 128)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateLabel("Dieses Programm ist Freeware." & @CRLF & "Es darf sowohl privat wie auch gewerblich genutzt werden." & @CRLF & @CRLF &"nderungen bedrfen meiner Zustimmung!"& @CRLF & "by Schnuffel at autoit.de ", 150, 140, 220, 90)
	GUISetState(@SW_SHOW)
	For $i = 1 To 250 Step $einblenden
		_WinAPI_SetLayeredWindowAttributes($aboutgui, 0x010101, $i)
	Next
	While 1
		$msg = GUIGetMsg()
		Switch $msg
			Case -3, $button
				ExitLoop
		EndSwitch
	WEnd
	For $i = 250 To 0 Step -$einblenden
		_WinAPI_SetLayeredWindowAttributes($aboutgui, 0x010101, $i)
	Next
	GUISetState(@SW_HIDE)
	GUIDelete($aboutgui)
EndFunc   ;==>_about

Func _Exit()
	DllClose($dll)
	Exit
EndFunc   ;==>_Exit
